﻿if not LibStub("LibPeriodicTable-3.1", true) then error("LibPeriodicTable-3.1 must be loaded before data") end
local PT = LibStub("LibPeriodicTable-3.1", true)

function Liquid_Wealth:NewFilter(Name,PTSetName,FilterType,Icon)
	if not Liquid_Wealth.db.realm.toon[UnitName("player")].filters then
		Liquid_Wealth.db.realm.toon[UnitName("player")].filters = {};
	end
	if not Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name] then
		Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name]={};
	end
	if not Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings then
		Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings={};
	end
	local currentIndex = table.getn(Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings);
	--print("Current Index: "..currentIndex)
	currentIndex=currentIndex+1;
	--print("Index Updated: "..currentIndex)
	if not Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings[currentIndex] then
		Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings[currentIndex]={}
	end
	Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings[currentIndex].setname=PTSetName
	Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].ptsetings[currentIndex].type=FilterType
	Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].vender=0
	Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].auction=0
	_, _, _, _, _, _, _, _,_, ItemTexturePath, _ = GetItemInfo(Icon)
	Liquid_Wealth.db.realm.toon[UnitName("player")].filters[Name].icon=ItemTexturePath
end

function Liquid_Wealth:showFilterToolTip()
    modeHeader = tip:AddLine("")
	local LWWhite18FontFont = CreateFont("LWWhite18FontFont")
	LWWhite18FontFont:SetFont(GameTooltipText:GetFont(), 18)
	LWWhite18FontFont:SetTextColor(255,255,255)
    tip:SetCell(modeHeader, 1, "Filters", LWWhite18FontFont, "CENTER", 5)
	tip:AddLine("")
	tip:AddSeparator(2)
	tip:AddLine("")
	modeHeader = tip:AddLine("")
	tip:SetCell(modeHeader, 2, "[Name]", nil, "CENTER")
	tip:SetCell(modeHeader, 4, "[Vender]", nil, "CENTER")
	tip:SetCell(modeHeader, 5, "[Auctions]", nil, "CENTER")
	--print(#Liquid_Wealth.db.realm.toon[UnitName("player")].filters)
	--if (Liquid_Wealth.db.realm.toon[UnitName("player")].filters == nil) or (#Liquid_Wealth.db.realm.toon[UnitName("player")].filters == 0) then
	local isFilters = false
	
	for filter in pairs(Liquid_Wealth.db.realm.toon[UnitName("player")].filters) do
		--print(filter)
		if (filter) then
			isFilters = true
		end
	end
	
	if (not isFilters) then
		modeHeader = tip:AddLine("")
		local LWYellow18FontFont = CreateFont("LWYellow18FontFont")
		LWYellow18FontFont:SetFont(GameTooltipText:GetFont(), 18)
		LWYellow18FontFont:SetTextColor(252,194,0)
		tip:SetCell(modeHeader, 1, "Please GoTo Add-on Options, and Set-up Filters", LWYellow18FontFont, "CENTER",5)
	else
		for filter in pairs(Liquid_Wealth.db.realm.toon[UnitName("player")].filters) do
			modeHeader = tip:AddLine("")
			--_, _, _, _, _, _, _, _,_, ItemTexturePath, _ = GetItemInfo(Liquid_Wealth.db.realm.filters[filter].icon)
			tip:SetCell(modeHeader, 1, "|T" .. Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].icon .. ":25|t", nil, "CENTER")
			local LWYellow18FontFont = CreateFont("LWYellow18FontFont")
			LWYellow18FontFont:SetFont(GameTooltipText:GetFont(), 18)
			LWYellow18FontFont:SetTextColor(252,194,0)
			tip:SetCell(modeHeader, 2, filter, LWYellow18FontFont, "CENTER")
			if filter == "Enchanting" then
				tip:SetCell(modeHeader, 4, "N/A", LWWhite18FontFont, "CENTER", 1)
			else
				tip:SetCell(modeHeader, 4, Liquid_Wealth:copperToText(Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].vender), LWWhite18FontFont, "CENTER", 1)
			end
			
			tip:SetCell(modeHeader, 5, Liquid_Wealth:copperToText(Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].auction), LWWhite18FontFont, "CENTER", 1)
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------- Deprecated Function ------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function Liquid_Wealth:ScanPT()
	if Liquid_Wealth.db.realm.filters then
		for bagId = -1, 11 do -- Add up the value of each bag's contents
			local bagSlots = GetContainerNumSlots(bagId);
			if (bagSlots > 0) then
				for slot = 1, bagSlots do
					local slotTotalAuction = 0
					local slotTotalVender = 0
					for filter in pairs(Liquid_Wealth.db.realm.filters) do
						local itemLink = GetContainerItemLink(bagId, slot);
						if (itemLink) and PT:ItemInSet(itemLink, Liquid_Wealth.db.realm.filters[filter].ptsetings[1].setname) and IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then
							local _, itemCount = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
							if not Liquid_Wealth:IsItemSoulbound(bagId, slot) then
								itemsPriceAuction = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
							end
							local _, _, _, _, _, _, _, _,_, _, itemsPriceVender=GetItemInfo(itemLink)
							if (itemsPriceAuction) or (itemsPriceVender) then
								PriceTotal = 0
								PriceTotal = itemCount * itemsPriceAuction;
								slotTotalAuction = slotTotalAuction + floor(PriceTotal);
								Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].auction=Liquid_Wealth.db.realm.filters[filter].auction + slotTotalAuction
								PriceTotal = 0
								PriceTotal = itemCount * itemsPriceVender;
								slotTotalVender = slotTotalVender + floor(PriceTotal);
								Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].vender=Liquid_Wealth.db.realm.filters[filter].vender + slotTotalVender
							end
						end
					end
				end
			end
		end
	end
end
----------------------------------------------------------------------------------^------------------------------------------------------^--------------------------------------------------------------
----------------------------------------------------------------------------------|------------ Deprecated Function ---------------------|--------------------------------------------------------------
----------------------------------------------------------------------------------|------------------------------------------------------|--------------------------------------------------------------

function Liquid_Wealth:ScanFilters(bagId)
	if Liquid_Wealth.db.realm.toon[UnitName("player")].filters then
		for filter in pairs(Liquid_Wealth.db.realm.toon[UnitName("player")].filters) do
			local bagSlots = GetContainerNumSlots(bagId);
			if (bagSlots > 0) then
				for slot = 1, bagSlots do
					local itemLink = GetContainerItemLink(bagId, slot);
					--print(itemLink..":"..bagId..":"..slot)
					if (itemLink) and PT:ItemInSet(itemLink, Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].ptsetings[1].setname) then
						local _, itemCount = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
						if not Liquid_Wealth:IsItemSoulbound(bagId, slot) and IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then
						itemsPriceAuction = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
						end
						local _, _, _, _, _, _, _, _,_, _, itemsPriceVender=GetItemInfo(itemLink)
						if (itemsPriceVender == nil) then itemsPriceVender=0 end
						if (itemsPriceAuction == nil) then itemsPriceAuction=0 end
						--print(itemLink..":".."Auction:"..itemsPriceAuction)
						--print(itemLink..":".."Vendor:"..itemsPriceVender)
						if (itemsPriceAuction) or (itemsPriceVender) then
							Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].auction=Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].auction + (itemCount*itemsPriceAuction)
							Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].vender=Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].vender + (itemCount*itemsPriceVender)
						end
					end
				end
			end
		end
	end
end